libstdc++: std::map< _Key, _Tp, _Compare, _Alloc > Class Template Reference

libstdc++

std::map< _Key, _Tp, _Compare, _Alloc > Class Template Reference
Containers » Associative

`#include <map>`

## Public Types
typedef _Alloc | allocator_type
typedef _Rep_type::const_iterator | const_iterator
typedef _Alloc_traits::const_pointer | const_pointer
typedef _Alloc_traits::const_reference | const_reference
typedef _Rep_type::const_reverse_iterator | const_reverse_iterator
typedef _Rep_type::difference_type | difference_type
typedef _Rep_type::iterator | iterator
typedef _Compare | key_compare
typedef _Key | key_type
typedef _Tp | mapped_type
typedef _Alloc_traits::pointer | pointer
typedef _Alloc_traits::reference | reference
typedef _Rep_type::reverse_iterator | reverse_iterator
typedef _Rep_type::size_type | size_type
typedef std::pair< const _Key, _Tp > | value_type

## Public Member Functions
| map ()=default
template<typename _InputIterator>
| map (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
| map (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<typename _InputIterator>
| map (_InputIterator __first, _InputIterator __last, const allocator_type &__a)
| map (const _Compare &__comp, const allocator_type &__a=allocator_type())
| map (const allocator_type &__a)
| map (const map &)=default
| map (const map &__m, const __type_identity_t< allocator_type > &__a)
| map (initializer_list< value_type > __l, const _Compare &__comp=_Compare(), const allocator_type &__a=allocator_type())
| map (initializer_list< value_type > __l, const allocator_type &__a)
| map (map &&)=default
| map (map &&__m, const __type_identity_t< allocator_type > &__a) noexcept(is_nothrow_copy_constructible< _Compare >::value &&_Alloc_traits::_S_always_equal())
| ~map ()=default
template<__heterogeneous_tree_key< map > _Kt>
mapped_type & | at (const _Kt &__k)
template<__heterogeneous_tree_key< map > _Kt>
const mapped_type & | at (const _Kt &__k) const
mapped_type & | at (const key_type &__k)
const mapped_type & | at (const key_type &__k) const
const_iterator | begin () const noexcept
iterator | begin () noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
std::pair< iterator, bool > | emplace (_Args &&... __args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&... __args)
bool | empty () const noexcept
const_iterator | end () const noexcept
iterator | end () noexcept
iterator | erase (const_iterator __first, const_iterator __last)
allocator_type | get_allocator () const noexcept
template<typename _InputIterator>
void | insert (_InputIterator __first, _InputIterator __last)
void | insert (std::initializer_list< value_type > __list)
key_compare | key_comp () const
size_type | max_size () const noexcept
map & | operator= (const map &)=default
map & | operator= (initializer_list< value_type > __l)
map & | operator= (map &&)=default
template<__heterogeneous_tree_key< map > _Kt>
mapped_type & | operator[] (_Kt &&__k)
mapped_type & | operator[] (const key_type &__k)
mapped_type & | operator[] (key_type &&__k)
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
size_type | size () const noexcept
void | swap (map &__x) noexcept(/*conditional */)
value_compare | value_comp () const
std::pair< iterator, bool > | insert (const value_type &__x)
std::pair< iterator, bool > | insert (value_type &&__x)
template<typename _Pair>
__enable_if_t< is_constructible< value_type, _Pair >::value, pair< iterator, bool > > | insert (_Pair &&__x)
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
template<typename _Pair>
__enable_if_t< is_constructible< value_type, _Pair >::value, iterator > | insert (const_iterator __position, _Pair &&__x)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
size_type | erase (const key_type &__x)
template<__heterogeneous_tree_key< map > _Kt>
size_type | erase (_Kt &&__x)
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
size_type | count (const key_type &__x) const
bool | contains (const key_type &__x) const
template<typename _Kt>
auto | contains (const _Kt &__x) const -> decltype(_M_t._M_find_tr(__x), void(), true)
iterator | lower_bound (const key_type &__x)
const_iterator | lower_bound (const key_type &__x) const
iterator | upper_bound (const key_type &__x)
const_iterator | upper_bound (const key_type &__x) const
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const

## Friends
template<typename _K1, typename _T1, typename _C1, typename _A1>
__detail::__synth3way_t< pair< const _K1, _T1 > > | operator<=> (const map< _K1, _T1, _C1, _A1 > &, const map< _K1, _T1, _C1, _A1 > &)
template<typename _K1, typename _T1, typename _C1, typename _A1>
bool | operator== (const map< _K1, _T1, _C1, _A1 > &, const map< _K1, _T1, _C1, _A1 > &)

## Detailed Description

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
class std::map< _Key, _Tp, _Compare, _Alloc >

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time.

Since
  C++98

Template Parameters

  _Key | Type of key objects.
  _Tp | Type of mapped objects.
  _Compare | Comparison function object type, defaults to less<_Key>.
  _Alloc | Allocator type, defaults to allocator<pair<const _Key, _Tp>.

Meets the requirements of a container, a reversible container, and an associative container (using unique keys). For a `map<Key,T>` the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Maps support bidirectional iterators.

The private tree data is declared exactly the same way for map and multimap; the distinction is made entirely in how the tree functions are called (*_unique versus *_equal, same as the standard).

Definition at line 106 of file stl_map.h.

## Member Typedef Documentation

## ◆ allocator_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Alloc std::map< _Key, _Tp, _Compare, _Alloc >::allocator_type

Definition at line 113 of file stl_map.h.

## ◆ const_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::const_iterator

Definition at line 181 of file stl_map.h.

## ◆ const_pointer

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Alloc_traits::const_pointer std::map< _Key, _Tp, _Compare, _Alloc >::const_pointer

Definition at line 177 of file stl_map.h.

## ◆ const_reference

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Alloc_traits::const_reference std::map< _Key, _Tp, _Compare, _Alloc >::const_reference

Definition at line 179 of file stl_map.h.

## ◆ const_reverse_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::const_reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::const_reverse_iterator

Definition at line 185 of file stl_map.h.

## ◆ difference_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::difference_type std::map< _Key, _Tp, _Compare, _Alloc >::difference_type

Definition at line 183 of file stl_map.h.

## ◆ iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::iterator std::map< _Key, _Tp, _Compare, _Alloc >::iterator

Definition at line 180 of file stl_map.h.

## ◆ key_compare

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Compare std::map< _Key, _Tp, _Compare, _Alloc >::key_compare

Definition at line 112 of file stl_map.h.

## ◆ key_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Key std::map< _Key, _Tp, _Compare, _Alloc >::key_type

Definition at line 109 of file stl_map.h.

## ◆ mapped_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Tp std::map< _Key, _Tp, _Compare, _Alloc >::mapped_type

Definition at line 110 of file stl_map.h.

## ◆ pointer

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Alloc_traits::pointer std::map< _Key, _Tp, _Compare, _Alloc >::pointer

Definition at line 176 of file stl_map.h.

## ◆ reference

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Alloc_traits::reference std::map< _Key, _Tp, _Compare, _Alloc >::reference

Definition at line 178 of file stl_map.h.

## ◆ reverse_iterator

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::reverse_iterator

Definition at line 184 of file stl_map.h.

## ◆ size_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef _Rep_type::size_type std::map< _Key, _Tp, _Compare, _Alloc >::size_type

Definition at line 182 of file stl_map.h.

## ◆ value_type

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

typedef std::pair<const _Key, _Tp> std::map< _Key, _Tp, _Compare, _Alloc >::value_type

Definition at line 111 of file stl_map.h.

## Constructor & Destructor Documentation

## ◆ map() [1/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( |  | ) |
| default

Default constructor creates no elements.

## ◆ map() [2/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicit

Creates a map with no elements.

Parameters

  __comp | A comparison object.
  __a | An allocator object.

Definition at line 210 of file stl_map.h.

## ◆ map() [3/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | const map< _Key, _Tp, _Compare, _Alloc > & |  | ) |
| default

Map copy constructor.

Whether the allocator is copied depends on the allocator traits.

## ◆ map() [4/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | map< _Key, _Tp, _Compare, _Alloc > && |  | ) |
| default

Map move constructor.

The newly-created map contains the exact contents of the moved instance. The moved instance is a valid, but unspecified, map.

## ◆ map() [5/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | initializer_list< value_type > | __l,
|  | const _Compare & | __comp = _Compare(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a map from an initializer_list.

Parameters

  __l | An initializer_list.
  __comp | A comparison object.
  __a | An allocator object.

Create a map consisting of copies of the elements in the initializer_list __l. This is linear in N if the range is already sorted, and NlogN otherwise (where N is __l.size()).

Definition at line 244 of file stl_map.h.

## ◆ map() [6/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | const allocator_type & | __a | ) |
| inlineexplicit

Allocator-extended default constructor.

Definition at line 252 of file stl_map.h.

## ◆ map() [7/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | const map< _Key, _Tp, _Compare, _Alloc > & | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inline

Allocator-extended copy constructor.

Definition at line 256 of file stl_map.h.

## ◆ map() [8/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | map< _Key, _Tp, _Compare, _Alloc > && | __m,
|  | const __type_identity_t< allocator_type > & | __a )
| inlinenoexcept

Allocator-extended move constructor.

Definition at line 260 of file stl_map.h.

## ◆ map() [9/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a )
| inline

Allocator-extended initializer-list constructor.

Definition at line 266 of file stl_map.h.

## ◆ map() [10/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a )
| inline

Allocator-extended range constructor.

Definition at line 272 of file stl_map.h.

## ◆ map() [11/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Builds a map from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.

Create a map consisting of copies of the elements from [__first,__last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(__first,__last)).

Definition at line 289 of file stl_map.h.

## ◆ map() [12/12]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

std::map< _Key, _Tp, _Compare, _Alloc >::map | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type() )
| inline

Builds a map from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __comp | A comparison functor.
  __a | An allocator object.

Create a map consisting of copies of the elements from [__first,__last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(__first,__last)).

Definition at line 306 of file stl_map.h.

## ◆ ~map()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::map< _Key, _Tp, _Compare, _Alloc >::~map | ( |  | ) |
| default

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

## Member Function Documentation

## ◆ at() [1/4]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<__heterogeneous_tree_key< map > _Kt>

mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::at | ( | const _Kt & | __k | ) |
| inline

Definition at line 597 of file stl_map.h.

## ◆ at() [2/4]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<__heterogeneous_tree_key< map > _Kt>

const mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::at | ( | const _Kt & | __k | ) | const
| inline

Definition at line 618 of file stl_map.h.

## ◆ at() [3/4]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::at | ( | const key_type & | __k | ) |
| inline

Access to map data.

Parameters

  __k | The key for which data should be retrieved.

Returns
  A reference to the data whose key is equivalent to __k, if such a data is present in the map.

Exceptions

  std::out_of_range | If no such data is present.

If a heterogeneous key __k matches a range of elements, the first is chosen.

Definition at line 586 of file stl_map.h.

## ◆ at() [4/4]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::at | ( | const key_type & | __k | ) | const
| inline

Definition at line 607 of file stl_map.h.

## ◆ begin() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::begin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 401 of file stl_map.h.

## ◆ begin() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::begin | ( |  | ) |
| inlinenoexcept

Returns a read/write iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 392 of file stl_map.h.

## ◆ cbegin()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 465 of file stl_map.h.

## ◆ cend()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 474 of file stl_map.h.

## ◆ clear()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

void std::map< _Key, _Tp, _Compare, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases all elements in a map. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1378 of file stl_map.h.

## ◆ contains() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Kt>

auto std::map< _Key, _Tp, _Compare, _Alloc >::contains | ( | const _Kt & | __x | ) | const -> decltype(_M_t._M_find_tr(__x), void(), true)
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of (key, value) pairs to be located.

Returns
  True if there is an element with the specified key.

Definition at line 1484 of file stl_map.h.

## ◆ contains() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

bool std::map< _Key, _Tp, _Compare, _Alloc >::contains | ( | const key_type & | __x | ) | const
| inline

Finds whether an element with the given key exists.

Parameters

  __x | Key of (key, value) pairs to be located.

Returns
  True if there is an element with the specified key.

Definition at line 1479 of file stl_map.h.

## ◆ count()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::map< _Key, _Tp, _Compare, _Alloc >::count | ( | const key_type & | __x | ) | const
| inline

Finds the number of elements with given key.

Parameters

  __x | Key of (key, value) pairs to be located.

Returns
  Number of elements with specified key.

This function only makes sense for multimaps; for map the result will either be 0 (not present) or 1 (present).

Definition at line 1460 of file stl_map.h.

## ◆ crbegin()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::crbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 483 of file stl_map.h.

## ◆ crend()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::crend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys.

Definition at line 492 of file stl_map.h.

## ◆ emplace()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

std::pair< iterator, bool > std::map< _Key, _Tp, _Compare, _Alloc >::emplace | ( | _Args &&... | __args | ) |
| inline

Attempts to build and insert a std::pair into the map.

Parameters

  __args | Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to build and insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 649 of file stl_map.h.

## ◆ emplace_hint()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename... _Args>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args )
| inline

Attempts to build and insert a std::pair into the map.

Parameters

  __pos | An iterator that serves as a hint as to where the pair should be inserted.
  __args | Arguments used to generate a new pair instance (see std::piecewise_contruct for passing arguments to each part of the pair constructor).

Returns
  An iterator that points to the element with key of the std::pair built from __args (may or may not be that std::pair).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument emplace() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 699 of file stl_map.h.

Referenced by std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::emplace(), and std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::insert().

## ◆ empty()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

bool std::map< _Key, _Tp, _Compare, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the map is empty. (Thus begin() would equal end().)

Definition at line 501 of file stl_map.h.

## ◆ end() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::end | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 419 of file stl_map.h.

## ◆ end() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::end | ( |  | ) |
| inlinenoexcept

Returns a read/write iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 410 of file stl_map.h.

Referenced by std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::at(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::emplace(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::insert(), and std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::operator[]().

## ◆ equal_range() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, iterator > std::map< _Key, _Tp, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) |
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key of (key, value) pairs to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

std::make_pair(c.lower_bound(val),
c.upper_bound(val))
std::make_pair
constexpr pair< typename __decay_and_strip< _T1 >::__type, typename __decay_and_strip< _T2 >::__type > make_pair(_T1 &&__x, _T2 &&__y)
A convenience wrapper for creating a pair from two objects.
Definition stl_pair.h:1169

(but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 1597 of file stl_map.h.

## ◆ equal_range() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< const_iterator, const_iterator > std::map< _Key, _Tp, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | const
| inline

Finds a subsequence matching given key.

Parameters

  __x | Key of (key, value) pairs to be located.

Returns
  Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

std::make_pair(c.lower_bound(val),
c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 1626 of file stl_map.h.

## ◆ erase() [1/5]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<__heterogeneous_tree_key< map > _Kt>

size_type std::map< _Key, _Tp, _Compare, _Alloc >::erase | ( | _Kt && | __x | ) |
| inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1311 of file stl_map.h.

## ◆ erase() [2/5]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::map< _Key, _Tp, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) |
| inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1302 of file stl_map.h.

## ◆ erase() [3/5]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inline

Erases a [first,last) range of elements from a map.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator __last.

This function erases a sequence of elements from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1333 of file stl_map.h.

## ◆ erase() [4/5]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::erase | ( | const_iterator | __position | ) |
| inline

Erases an element from a map.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1264 of file stl_map.h.

## ◆ erase() [5/5]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::erase | ( | iterator | __position | ) |
| inline

Erases an element from a map.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1270 of file stl_map.h.

## ◆ find() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::find | ( | const key_type & | __x | ) |
| inline

Tries to locate an element in a map.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1414 of file stl_map.h.

## ◆ find() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | const
| inline

Tries to locate an element in a map.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1439 of file stl_map.h.

## ◆ get_allocator()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

allocator_type std::map< _Key, _Tp, _Compare, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Get a copy of the memory allocation object.

Definition at line 382 of file stl_map.h.

## ◆ insert() [1/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _InputIterator>

void std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Template function that attempts to insert a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 1077 of file stl_map.h.

## ◆ insert() [2/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair>

__enable_if_t< is_constructible< value_type, _Pair >::value, pair< iterator, bool > > std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | _Pair && | __x | ) |
| inline

Attempts to insert a std::pair into the map.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 964 of file stl_map.h.

## ◆ insert() [3/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, bool > std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | const value_type & | __x | ) |
| inline

Attempts to insert a std::pair into the map.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 951 of file stl_map.h.

Referenced by std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::insert(), and std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::operator[]().

## ◆ insert() [4/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<typename _Pair>

__enable_if_t< is_constructible< value_type, _Pair >::value, iterator > std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | const_iterator | __position,
|  | _Pair && | __x )
| inline

Attempts to insert a std::pair into the map.

Parameters

  __position | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 1059 of file stl_map.h.

## ◆ insert() [5/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | const_iterator | __position,
|  | const value_type & | __x )
| inline

Attempts to insert a std::pair into the map.

Parameters

  __position | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 1044 of file stl_map.h.

## ◆ insert() [6/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | const_iterator | __position,
|  | value_type && | __x )
| inline

Attempts to insert a std::pair into the map.

Parameters

  __position | An iterator that serves as a hint as to where the pair should be inserted.
  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  An iterator that points to the element with key of __x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints for more on hinting.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 1054 of file stl_map.h.

## ◆ insert() [7/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

void std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | std::initializer_list< value_type > | __list | ) |
| inline

Attempts to insert a list of std::pairs into the map.

Parameters

  __list | A std::initializer_list<value_type> of pairs to be inserted.

Complexity similar to that of the range constructor.

Definition at line 996 of file stl_map.h.

## ◆ insert() [8/8]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

std::pair< iterator, bool > std::map< _Key, _Tp, _Compare, _Alloc >::insert | ( | value_type && | __x | ) |
| inline

Attempts to insert a std::pair into the map.

Parameters

  __x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns
  A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 958 of file stl_map.h.

## ◆ key_comp()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

key_compare std::map< _Key, _Tp, _Compare, _Alloc >::key_comp | ( |  | ) | const
| inline

Returns the key comparison object out of which the map was constructed.

Definition at line 1387 of file stl_map.h.

Referenced by std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::at(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::emplace(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::insert(), and std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::operator[]().

## ◆ lower_bound() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) |
| inline

Finds the beginning of a subsequence matching given key.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 1503 of file stl_map.h.

Referenced by std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::at(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::emplace(), std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::insert(), and std::map< _Key, _Tp, _Cmp, polymorphic_allocator< pair< const _Key, _Tp > > >::operator[]().

## ◆ lower_bound() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | const
| inline

Finds the beginning of a subsequence matching given key.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 1528 of file stl_map.h.

## ◆ max_size()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::map< _Key, _Tp, _Compare, _Alloc >::max_size | ( |  | ) | const
| inlinenoexcept

Returns the maximum size of the map.

Definition at line 511 of file stl_map.h.

## ◆ operator=() [1/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

map & std::map< _Key, _Tp, _Compare, _Alloc >::operator= | ( | const map< _Key, _Tp, _Compare, _Alloc > & |  | ) |
| default

Map assignment operator.

Whether the allocator is copied depends on the allocator traits.

## ◆ operator=() [2/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

map & std::map< _Key, _Tp, _Compare, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |
| inline

Map list assignment operator.

Parameters

  __l | An initializer_list.

This function fills a map with copies of the elements in the initializer list __l.

Note that the assignment completely changes the map and that the resulting map's size is the same as the number of elements assigned.

Definition at line 373 of file stl_map.h.

## ◆ operator=() [3/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

map & std::map< _Key, _Tp, _Compare, _Alloc >::operator= | ( | map< _Key, _Tp, _Compare, _Alloc > && |  | ) |
| default

Move assignment operator.

## ◆ operator[]() [1/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>
template<__heterogeneous_tree_key< map > _Kt>

mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::operator[] | ( | _Kt && | __k | ) |
| inline

Definition at line 569 of file stl_map.h.

## ◆ operator[]() [2/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::operator[] | ( | const key_type & | __k | ) |
| inline

Subscript ( ``[] ) access to map data.

Parameters

  __k | The key for which data should be retrieved.

Returns
  A reference to the data of the (key,data) pair.

Allows for easy lookup with the subscript ( ``[] ) operator. Returns data associated with the key specified in subscript. If the key does not exist, a pair with that key is created using default values, which is then returned.

If a heterogeneous key matches a range of elements, the first is chosen.

Lookup requires logarithmic time.

Definition at line 531 of file stl_map.h.

## ◆ operator[]() [3/3]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

mapped_type & std::map< _Key, _Tp, _Compare, _Alloc >::operator[] | ( | key_type && | __k | ) |
| inline

Definition at line 551 of file stl_map.h.

## ◆ rbegin() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::rbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 437 of file stl_map.h.

## ◆ rbegin() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::rbegin | ( |  | ) |
| inlinenoexcept

Returns a read/write reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 428 of file stl_map.h.

## ◆ rend() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::rend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys.

Definition at line 455 of file stl_map.h.

## ◆ rend() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

reverse_iterator std::map< _Key, _Tp, _Compare, _Alloc >::rend | ( |  | ) |
| inlinenoexcept

Returns a read/write reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys.

Definition at line 446 of file stl_map.h.

## ◆ size()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

size_type std::map< _Key, _Tp, _Compare, _Alloc >::size | ( |  | ) | const
| inlinenoexcept

Returns the size of the map.

Definition at line 506 of file stl_map.h.

## ◆ swap()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

void std::map< _Key, _Tp, _Compare, _Alloc >::swap | ( | map< _Key, _Tp, _Compare, _Alloc > & | __x | ) |
| inlinenoexcept

Swaps data with another map.

Parameters

  __x | A map of the same element and allocator types.

This exchanges the elements between two maps in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Whether the allocators are swapped depends on the allocator traits.

Definition at line 1367 of file stl_map.h.

## ◆ upper_bound() [1/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

iterator std::map< _Key, _Tp, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) |
| inline

Finds the end of a subsequence matching given key.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Iterator pointing to the first element greater than key, or end().

Definition at line 1548 of file stl_map.h.

## ◆ upper_bound() [2/2]

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

const_iterator std::map< _Key, _Tp, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | const
| inline

Finds the end of a subsequence matching given key.

Parameters

  __x | Key of (key, value) pair to be located.

Returns
  Read-only (constant) iterator pointing to first iterator greater than key, or end().

Definition at line 1568 of file stl_map.h.

## ◆ value_comp()

template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >>

value_compare std::map< _Key, _Tp, _Compare, _Alloc >::value_comp | ( |  | ) | const
| inline

Returns a value comparison object, built from the key comparison object out of which the map was constructed.

Definition at line 1395 of file stl_map.h.

The documentation for this class was generated from the following file:

- stl_map.h